# CEGUI Namespace Reference

Main namespace for Crazy Eddie's GUI Library. More...

## Classes

class | colour
| Class representing colour values within the system. More...
class | ColourRect
| Class that holds details of colours for the four corners of a rectangle. More...
class | Config_xmlHandler
| Handler class used to parse the Configuration XML file. More...
class | DataContainer
class | RawDataContainer
class | DefaultResourceProvider
class | SubscriberInterface
| The base class for the various binders. This provides a consistent interface for firing functions bound to an event. More...
class | _freeBinder
| This class binds a free function. More...
class | _functorBinder
| This class binds a copy of a functor. More...
class | _memberBinder
| This class binds a member function along with a target object. More...
class | SubscriberTemplate
| This template describes the Subscriber class. It is a wrapper for a pointer to a SubscriberInterface with various constructors that will by implicit conversion construct the various binders. More...
class | _refBinder
| This class binds a const reference to a generalized functor. Sometimes it may not be appropriate for the functor to be cloned. In which case, use SubscriberRef() (which uses this). More...
class | Event
| Defines an 'event' which can be subscribed to by interested parties. More...
class | EventArgs
| Base class used as the argument to all subscribers Event object. More...
class | EventSet
| Class that collects together a set of Event objects. More...
class | Exception
| Root exception class used within the GUI system. More...
class | GenericException
| Exception class used when none of the other classes are applicable. More...
class | UnknownObjectException
| Exception class used when a request was made using a name of an unknown object. More...
class | InvalidRequestException
| Exception class used when some impossible request was made for the current system state. More...
class | FileIOException
| Exception class used when a file handling problem occurs. More...
class | RendererException
| Exception class used when an problem is detected within the Renderer or related objects. More...
class | AlreadyExistsException
| Exception class used when an attempt is made to use an object name that is already in use within the system. More...
class | MemoryException
| Exception class used when a memory handling error is detected. More...
class | NullObjectException
| Exception class used when some required object or parameter is null. More...
class | ObjectInUseException
| Exception class used when some attempt to delete, remove, or otherwise invalidate some object that is still in use occurs. More...
class | FactoryModule
| Class that encapsulates access to a dynamic loadable module containing implementations of Windows, Widgets, and their factories. More...
class | Font
| Class that encapsulates text rendering functionality for a typeface. More...
class | Font_xmlHandler
| Handler class used to parse the Font XML files using SAX2. More...
class | FontManager
| Class providing a shared library of Font objects to the system. More...
class | GlobalEventSet
| The GlobalEventSet singleton allows you to subscribe to an event for all instances of a class. The GlobalEventSet effectively supports "late binding" to events; which means you can subscribe to some event that does not actually exist (yet). More...
class | GUILayout_xmlHandler
| Handler class used to parse the GUILayout XML files using SAX2. More...
class | Image
| Class that represents a single Image of an Imageset. More...
class | Imageset
| Offers functions to define, access, and draw, a set of image components on a single graphical surface or Texture. More...
class | Imageset_xmlHandler
| Handler class used to parse the Imageset XML files using SAX2. More...
class | ImagesetManager
| Class providing a shared library of Imageset objects to the system. More...
struct | Key
| struct to give scope to scan code enumeration. More...
class | WindowEventArgs
| EventArgs based class that is used for objects passed to handlers triggered for events concerning some Window object. More...
class | MouseEventArgs
| EventArgs based class that is used for objects passed to input event handlers concerning mouse input. More...
class | MouseCursorEventArgs
| EventArgs based class that is used for objects passed to input event handlers concerning mouse cursor events. More...
class | KeyEventArgs
| EventArgs based class that is used for objects passed to input event handlers concerning keyboard input. More...
class | ActivationEventArgs
| EventArgs based class that is used for Activated and Deactivated window events. More...
class | DragDropEventArgs
| EventArgs based class used for certain drag/drop notifications. More...
class | ConstBaseIterator
| Base class constant iterator used to offer iteration over various collections within the system. More...
class | Logger
| Class that implements logging for the GUI system. More...
class | MouseCursor
| Class that allows access to the GUI system mouse cursor. More...
class | PropertyReceiver
| Dummy base class to ensure correct casting of receivers. More...
class | Property
| An abstract class that defines the interface to access object properties by name. More...
class | PropertyHelper
| Helper class used to convert various data types to and from the format expected in Propery strings. More...
class | PropertySet
| Class that contains a collection of Property objects. More...
class | Rect
| Class encapsulating operations on a Rectangle. More...
class | Referenced
class | RefPtr
class | RenderableElement
class | RenderableFrame
| A higher order GUI entity that represents a renderable frame. More...
class | RenderableImage
| A higher order GUI entity that represents a renderable image with formatting options. More...
class | RenderCache
| Class that acts as a cache for images that need to be rendered. More...
class | Renderer
| Abstract class defining the interface for Renderer objects. More...
class | ResourceProvider
| Abstract class that defines the required interface for all resource provider sub-classes. More...
class | Scheme
| A class that groups a set of GUI elements and initialises the system to access those elements. More...
class | Scheme_xmlHandler
| Handler class used to parse the Scheme XML files using SAX2. More...
class | SchemeManager
| A class that manages the creation of, access to, and destruction of GUI Scheme objects. More...
class | ScriptModule
| Abstract interface required for all scripting support modules to be used with the CEGUI system. More...
class | ScriptFunctor
| Functor class used for binding named script functions to events. More...
class | Singleton
class | Size
| Class that holds the size (width & height) of something. More...
class | String
| String class used within the GUI system. More...
class | System
| The System class is the CEGUI class that provides access to all other elements in this system. More...
class | Texture
| Abstract base class specifying the required interface for Texture objects. More...
class | TextUtils
| Text utility support class. This class is all static members. You do not create instances of this class. More...
class | TinyXMLParser
| Implementation of XMLParser using TinyXML. More...
class | UDim
| Class representing a unified dimension; that is a dimension that has both a relative 'scale' portion and and absolute 'offset' portion. More...
class | UVector2
| Two dimensional vector class built using unified dimensions (UDims). The UVector2 class is used for representing both positions and sizes. More...
class | URect
| Area rectangle class built using unified dimensions (UDims). More...
class | Vector2
| Class used as a two dimensional vector (aka a Point). More...
class | Vector3
| Class used as a three dimensional vector. More...
class | Window
| An abstract base class providing common functionality and specifying the required interface for derived classes. More...
class | WindowFactory
| Abstract class that defines the required interface for all WindowFactory objects. More...
class | WindowFactoryManager
| Class that manages WindowFactory objects. More...
class | WindowManager
| The WindowManager class describes an object that manages creation and lifetime of Window objects. More...
class | XercesHandler
class | XercesParser
| Implementation of XMLParser using Xerces-C++. More...
class | XMLAttributes
| Class representing a block of attributes associated with an XML element. More...
class | XMLHandler
class | XMLParser
| This is an abstract class that is used by CEGUI to interface with XML parser libraries. More...
class | ButtonBase
| Base class for all the 'button' type widgets (push button, radio button, check-box, etc). More...
class | Checkbox
| Base class providing logic for Check-box widgets. More...
class | Combobox
| Base class for the Combobox widget. More...
class | ComboDropList
| Base class for the combo box drop down list. This is a specialisation of the Listbox class. More...
class | DragContainer
| Generic drag & drop enabled window class. More...
class | DragContainerFactory
| Factory class for producing DragContainer windows. More...
class | Editbox
| Base class for an Editbox widget. More...
class | FrameWindow
| Abstract base class for a movable, sizable, window with a title-bar and a frame. More...
class | GUISheet
| Window class intended to be used as a simple, generic Window. More...
class | GUISheetFactory
| Factory class for producing default windows. More...
class | ItemEntry
| Base class for item type widgets. More...
class | ItemListBase
| Base class for item list widgets. More...
class | Listbox
| Base class for standard Listbox widget. More...
class | ListboxItem
| Base class for list box items. More...
class | ListboxTextItem
| Class used for textual items in a list box. More...
class | HeaderSequenceEventArgs
| EventArgs class used for segment move (sequence changed) events. More...
class | ListHeader
| Base class for the multi column list header widget. More...
class | ListHeaderSegment
| Base class for list header segment window. More...
class | Menubar
| Base class for menu bars. More...
class | MenuBase
| Abstract base class for menus. More...
class | MenuItem
| Base class for menu items. More...
struct | MCLGridRef
| Simple grid index structure. More...
class | MultiColumnList
| Base class for the multi column list widget. More...
class | MultiLineEditbox
| Base class for the multi-line edit box widget. More...
class | PopupMenu
| Base class for popup menus. More...
class | ProgressBar
| Base class for progress bars. More...
class | PushButton
| Base class to provide logic for push button type widgets. More...
class | RadioButton
| Base class to provide the logic for Radio Button widgets. More...
class | ScrollablePane
| Base class for the ScrollablePane widget. More...
class | Scrollbar
| Base scroll bar class. More...
class | ScrolledContainer
| Helper container window class which is used in the implementation of the ScrollablePane widget class. More...
class | ScrolledContainerFactory
| Factory class for producing ScrolledContainer windows. More...
class | Slider
| Base class for Slider widgets. More...
class | Spinner
| Base class for the Spinner widget. More...
class | Static
| Base class for static widgets. More...
class | StaticImage
| Static image widget class. More...
class | StaticText
| Base class for a static text widget. More...
class | TabButton
| Base class for TabButtons. A TabButton based class is used internally as the button that appears at the top of a TabControl widget to select the active tab pane. More...
class | TabControl
| Base class for standard Tab Control widget. More...
class | TabPane
| Base class for a tab pane. More...
class | TextItem
| Base class for all the TextItem widgets. More...
class | Thumb
| Base class for Thumb widget. More...
class | Titlebar
| Class representing the title bar for Frame Windows. More...
class | Tooltip
| Base class for Tooltip widgets. More...
class | Falagard_xmlHandler
| Handler class used to parse look & feel XML files used by the Falagard system. More...
class | FalagardComponentBase
| Common base class used for renderable components within an ImagerySection. More...
class | BaseDim
| Abstract interface for a generic 'dimension' class. More...
class | AbsoluteDim
| Dimension type that represents an absolute pixel value. Implements BaseDim interface. More...
class | ImageDim
| Dimension type that represents some dimension of a named Image. Implements BaseDim interface. More...
class | WidgetDim
| Dimension type that represents some dimension of a Window/widget. Implements BaseDim interface. More...
class | UnifiedDim
| Dimension type that represents an Unified dimension. Implements BaseDim interface. More...
class | FontDim
| Dimension type that represents some metric of a Font. Implements BaseDim interface. More...
class | PropertyDim
| Dimension type that represents the value of a Window property. Implements BaseDim interface. More...
class | Dimension
| Class representing some kind of dimension. More...
class | ComponentArea
| Class that represents a target area for a widget or imagery component. More...
class | FrameComponent
| Class that encapsulates information for a frame with background (9 images in total). More...
class | ImageryComponent
| Class that encapsulates information for a single image component. More...
class | ImagerySection
| Class that encapsulates a re-usable collection of imagery specifications. More...
class | LayerSpecification
| Class that encapsulates a single layer of imagery. More...
class | NamedArea
| NamedArea defines an area for a component which may later be obtained and referenced by a name unique to the WidgetLook holding the NamedArea. More...
class | PropertyDefinition
| class representing a new property to be available on all widgets that use the WidgetLook that this PropertyDefinition is defiend for. More...
class | PropertyInitialiser
| Class that holds information about a property and it's required initial value. More...
class | SectionSpecification
| Class that represents a simple 'link' to an ImagerySection. More...
class | StateImagery
| Class the encapsulates imagery for a given widget state. More...
class | TextComponent
| Class that encapsulates information for a text component. More...
class | WidgetComponent
| Class that encapsulates information regarding a sub-widget required for a widget. More...
class | WidgetLookFeel
| Class that encapsulates look & feel information for a particular widget type. More...
class | WidgetLookManager
| Manager class that gives top-level access to widget data based "look and feel" specifications loaded into the system. More...
class | FalagardXMLHelper
| Utility helper class primarily intended for use by the falagard xml parser. More...
class | DirectX81Renderer
| Renderer class to interface with Microsoft DirectX 8.1. More...
class | DirectX81Texture
| Texture class that is created by DirectX81Renderer objects. More...
class | DirectX9Renderer
| Renderer class to interface with Microsoft DirectX 9.0. More...
class | DirectX9Texture
| Texture class that is created by DirectX9Renderer objects. More...
class | IrrlichtRenderer
| class implementing the interface for Renderer objects with the irrlicht graphics engine. More...
class | IrrlichtResourceProvider
class | IrrlichtTexture
class | OpenGLRenderer
| Renderer class to interface with OpenGL. More...
class | OpenGLTexture
| Texture class that is created by OpenGLRenderer objects. More...
class | ConnectionImpl
class | SimpleTimer
| Simple timer class. More...
struct | MouseClickTracker
| Implementation structure used in tracking up & down mouse button inputs in order to generate click, double-click, and triple-click events. More...
struct | MouseClickTrackerImpl
class | TinyXMLDocument
struct | RegexValidator
| Internal struct to contain compiled regex string. More...
class | EventPusher

## Namespaces

namespace | ButtonBaseProperties
| Namespace containing all classes that make up the properties interface for the ButtonBase class.

namespace | CheckboxProperties
| Namespace containing all classes that make up the properties interface for the Checkbox class.

namespace | ComboboxProperties
| Namespace containing all classes that make up the properties interface for the Combobox class.

namespace | EditboxProperties
| Namespace containing all classes that make up the properties interface for the Editbox class.

namespace | FrameWindowProperties
| Namespace containing all classes that make up the properties interface for the FrameWindow class.

namespace | ListboxProperties
| Namespace containing all classes that make up the properties interface for the Listbox class.

namespace | ListHeaderProperties
| Namespace containing all classes that make up the properties interface for the ListHeader class.

namespace | ListHeaderSegmentProperties
| Namespace containing all classes that make up the properties interface for the ListHeaderSegment class.

namespace | MultiColumnListProperties
| Namespace containing all classes that make up the properties interface for the MultiColumnList class.

namespace | MultiLineEditboxProperties
| Namespace containing all classes that make up the properties interface for the MultiLineEditbox class.

namespace | ProgressBarProperties
| Namespace containing all classes that make up the properties interface for the ProgressBar class.

namespace | PushButtonProperties
| Namespace containing all classes that make up the properties interface for the PushButton class.

namespace | RadioButtonProperties
| Namespace containing all classes that make up the properties interface for the RadioButton class.

namespace | ScrollablePaneProperties
| Namespace containing all classes that make up the properties interface for the ScrollablePane class.

namespace | ScrollbarProperties
| Namespace containing all classes that make up the properties interface for the Scrollbar class.

namespace | ScrolledContainerProperties
| Namespace containing all classes that make up the properties interface for the ScrolledContainer class.

namespace | SliderProperties
| Namespace containing all classes that make up the properties interface for the Slider class.

namespace | StaticImageProperties
| Namespace containing all classes that make up the properties interface for the StaticImage class.

namespace | StaticProperties
| Namespace containing all classes that make up the properties interface for the Static (base) class.

namespace | StaticTextProperties
| Namespace containing all classes that make up the properties interface for the StaticText class.

namespace | TabControlProperties
| Namespace containing all classes that make up the properties interface for the Listbox class.

namespace | ThumbProperties
| Namespace containing all classes that make up the properties interface for the Thumb class.

namespace | TitlebarProperties
| Namespace containing all classes that make up the properties interface for the Titlebar class.

namespace | TooltipProperties
| Namespace containing all classes that make up the properties interface for the Tooltip class.

namespace | WindowProperties
| Namespace containing all classes that make up the properties interface for the Window base class.

## Typedefs

typedef unsigned long | ulong
typedef unsigned short | ushort
typedef unsigned int | uint
typedef unsigned char | uchar
typedef unsigned int | uint32
typedef unsigned short | uint16
typedef unsigned char | uint8
typedef std::ostream | OutStream
| Output stream class.
typedef uint32 | argb_t
| 32 bit ARGB representation of a colour.
typedef uint8 | utf8
typedef uint32 | utf32
typedef Vector2 | Point
| Point class.
typedef GUISheet | DefaultWindow
| typedef for DefaultWindow, which is the new name for GUISheet.

## Enumerations

enum | FontFlag { Default, NoAntiAlias }
| Enumerated type that contains the valid flags that can be passed to createFont when creating a new font. More...
enum | TextFormatting { LeftAligned, RightAligned, Centred, Justified, WordWrapLeftAligned, WordWrapRightAligned, WordWrapCentred, WordWrapJustified }
| Enumerated type that contains valid formatting types that can be specified when rendering text into a Rect area (the formatting Rect). More...
enum | MouseButton { LeftButton, RightButton, MiddleButton, X1Button, X2Button, MouseButtonCount, NoButton }
enum | SystemKey { LeftMouse = 0x0001, RightMouse = 0x0002, Shift = 0x0004, Control = 0x0008, MiddleMouse = 0x0010, X1Mouse = 0x0020, X2Mouse = 0x0040, Alt = 0x0080 }
| System key flag values. More...
enum | LoggingLevel { Errors, Standard, Informative, Insane }
| Enumeration of logging levels. More...
enum | MouseCursorImage { BlankMouseCursor = 0, DefaultMouseCursor = -1 }
| Enumeration of special values used for mouse cursor settings in Window objects. More...
enum | FrameLocation { Invalid, TopLeftCorner, TopRightCorner, BottomLeftCorner, BottomRightCorner, LeftEdge, TopEdge, RightEdge, BottomEdge }
| Enumeration of positions for a frame.
enum | OrientationFlags { FlipHorizontal = 1, FlipVertical = 2, RotateRightAngle = 4 }
| Enumerated type that contains the valid flags that can be to use when rendering image. More...
enum | QuadSplitMode { TopLeftToBottomRight, BottomLeftToTopRight }
| Enumerated type that contains the valid diagonal-mode that specify how a quad is split into triangles when rendered with fx. a 3D API. More...
enum | MetricsMode { Relative, Absolute, Inherited }
| Mode used for Window size and position metrics. More...
enum | VerticalAlignment { VA_TOP, VA_CENTRE, VA_BOTTOM }
| Enumerated type used when specifying vertical alignments. More...
enum | HorizontalAlignment { HA_LEFT, HA_CENTRE, HA_RIGHT }
| Enumerated type used when specifying horizontal alignments. More...
enum | DimensionType { DT_LEFT_EDGE, DT_X_POSITION, DT_TOP_EDGE, DT_Y_POSITION, DT_RIGHT_EDGE, DT_BOTTOM_EDGE, DT_WIDTH, DT_HEIGHT, DT_X_OFFSET, DT_Y_OFFSET, DT_INVALID }
| Enumeration of possible values to indicate what a given dimension represents. More...
enum | VerticalFormatting { VF_TOP_ALIGNED, VF_CENTRE_ALIGNED, VF_BOTTOM_ALIGNED, VF_STRETCHED, VF_TILED }
| Enumeration of possible values to indicate the vertical formatting to be used for an image component. More...
enum | HorizontalFormatting { HF_LEFT_ALIGNED, HF_CENTRE_ALIGNED, HF_RIGHT_ALIGNED, HF_STRETCHED, HF_TILED }
| Enumeration of possible values to indicate the horizontal formatting to be used for an image component. More...
enum | VerticalTextFormatting { VTF_TOP_ALIGNED, VTF_CENTRE_ALIGNED, VTF_BOTTOM_ALIGNED }
| Enumeration of possible values to indicate the vertical formatting to be used for a text component. More...
enum | HorizontalTextFormatting { HTF_LEFT_ALIGNED, HTF_RIGHT_ALIGNED, HTF_CENTRE_ALIGNED, HTF_JUSTIFIED, HTF_WORDWRAP_LEFT_ALIGNED, HTF_WORDWRAP_RIGHT_ALIGNED, HTF_WORDWRAP_CENTRE_ALIGNED, HTF_WORDWRAP_JUSTIFIED }
| Enumeration of possible values to indicate the horizontal formatting to be used for a text component. More...
enum | FontMetricType { FMT_LINE_SPACING, FMT_BASELINE, FMT_HORZ_EXTENT }
| Enumeration of possible values to indicate a particular font metric. More...
enum | DimensionOperator { DOP_NOOP, DOP_ADD, DOP_SUBTRACT, DOP_MULTIPLY, DOP_DIVIDE }
| Enumeration of values representing mathematical operations on dimensions. More...
enum | FrameImageComponent { FIC_BACKGROUND, FIC_TOP_LEFT_CORNER, FIC_TOP_RIGHT_CORNER, FIC_BOTTOM_LEFT_CORNER, FIC_BOTTOM_RIGHT_CORNER, FIC_LEFT_EDGE, FIC_RIGHT_EDGE, FIC_TOP_EDGE, FIC_BOTTOM_EDGE, FIC_FRAME_IMAGE_COUNT }
| Enumeration of values referencing available images forming a frame component. More...

## Functions

template<class Functor>
SubscriberInterface< bool, const EventArgs & > * | SubscriberRef (const Functor &f)
| This helper function produces a const reference binding.
bool CEGUIEXPORT | operator== (const String &str1, const String &str2)
| Return true if String str1 is equal to String str2.
bool CEGUIEXPORT | operator== (const String &str, const std::string &std_str)
| Return true if String str is equal to std::string std_str.
bool CEGUIEXPORT | operator== (const std::string &std_str, const String &str)
| Return true if String str is equal to std::string std_str.
bool CEGUIEXPORT | operator== (const String &str, const utf8 *utf8_str)
| Return true if String str is equal to null-terminated utf8 data utf8_str.
bool CEGUIEXPORT | operator== (const utf8 *utf8_str, const String &str)
| Return true if String str is equal to null-terminated utf8 data utf8_str.
bool CEGUIEXPORT | operator!= (const String &str1, const String &str2)
| Return true if String str1 is not equal to String str2.
bool CEGUIEXPORT | operator!= (const String &str, const std::string &std_str)
| Return true if String str is not equal to std::string std_str.
bool CEGUIEXPORT | operator!= (const std::string &std_str, const String &str)
| Return true if String str is not equal to std::string std_str.
bool CEGUIEXPORT | operator!= (const String &str, const utf8 *utf8_str)
| Return true if String str is not equal to null-terminated utf8 data utf8_str.
bool CEGUIEXPORT | operator!= (const utf8 *utf8_str, const String &str)
| Return true if String str is not equal to null-terminated utf8 data utf8_str.
bool CEGUIEXPORT | operator< (const String &str1, const String &str2)
| Return true if String str1 is lexicographically less than String str2.
bool CEGUIEXPORT | operator< (const String &str, const std::string &std_str)
| Return true if String str is lexicographically less than std::string std_str.
bool CEGUIEXPORT | operator< (const std::string &std_str, const String &str)
| Return true if String str is lexicographically less than std::string std_str.
bool CEGUIEXPORT | operator< (const String &str, const utf8 *utf8_str)
| Return true if String str is lexicographically less than null-terminated utf8 data utf8_str.
bool CEGUIEXPORT | operator< (const utf8 *utf8_str, const String &str)
| Return true if String str is lexicographically less than null-terminated utf8 data utf8_str.
bool CEGUIEXPORT | operator> (const String &str1, const String &str2)
| Return true if String str1 is lexicographically greater than String str2.
bool CEGUIEXPORT | operator> (const String &str, const std::string &std_str)
| Return true if String str is lexicographically greater than std::string std_str.
bool CEGUIEXPORT | operator> (const std::string &std_str, const String &str)
| Return true if String str is lexicographically greater than std::string std_str.
bool CEGUIEXPORT | operator> (const String &str, const utf8 *utf8_str)
| Return true if String str is lexicographically greater than null-terminated utf8 data utf8_str.
bool CEGUIEXPORT | operator> (const utf8 *utf8_str, const String &str)
| Return true if String str is lexicographically greater than null-terminated utf8 data utf8_str.
bool CEGUIEXPORT | operator<= (const String &str1, const String &str2)
| Return true if String str1 is lexicographically less than or equal to String str2.
bool CEGUIEXPORT | operator<= (const String &str, const std::string &std_str)
| Return true if String str is lexicographically less than or equal to std::string std_str.
bool CEGUIEXPORT | operator<= (const std::string &std_str, const String &str)
| Return true if String str is lexicographically less than or equal to std::string std_str.
bool CEGUIEXPORT | operator<= (const String &str, const utf8 *utf8_str)
| Return true if String str is lexicographically less than or equal to null-terminated utf8 data utf8_str.
bool CEGUIEXPORT | operator<= (const utf8 *utf8_str, const String &str)
| Return true if String str is lexicographically less than or equal to null-terminated utf8 data utf8_str.
bool CEGUIEXPORT | operator>= (const String &str1, const String &str2)
| Return true if String str1 is lexicographically greater than or equal to String str2.
bool CEGUIEXPORT | operator>= (const String &str, const std::string &std_str)
| Return true if String str is lexicographically greater than or equal to std::string std_str.
bool CEGUIEXPORT | operator>= (const std::string &std_str, const String &str)
| Return true if String str is lexicographically greater than or equal to std::string std_str.
bool CEGUIEXPORT | operator>= (const String &str, const utf8 *utf8_str)
| Return true if String str is lexicographically greater than or equal to null-terminated utf8 data utf8_str.
bool CEGUIEXPORT | operator>= (const utf8 *utf8_str, const String &str)
| Return true if String str is lexicographically greater than or equal to null-terminated utf8 data utf8_str.
bool CEGUIEXPORT | operator== (const String &str, const char *c_str)
| Return true if String str is equal to c-string c_str.
bool CEGUIEXPORT | operator== (const char *c_str, const String &str)
| Return true if c-string c_str is equal to String str.
bool CEGUIEXPORT | operator!= (const String &str, const char *c_str)
| Return true if String str is not equal to c-string c_str.
bool CEGUIEXPORT | operator!= (const char *c_str, const String &str)
| Return true if c-string c_str is not equal to String str.
bool CEGUIEXPORT | operator< (const String &str, const char *c_str)
| Return true if String str is lexicographically less than c-string c_str.
bool CEGUIEXPORT | operator< (const char *c_str, const String &str)
| Return true if c-string c_str is lexicographically less than String str.
bool CEGUIEXPORT | operator> (const String &str, const char *c_str)
| Return true if String str is lexicographically greater than c-string c_str.
bool CEGUIEXPORT | operator> (const char *c_str, const String &str)
| Return true if c-string c_str is lexicographically greater than String str.
bool CEGUIEXPORT | operator<= (const String &str, const char *c_str)
| Return true if String str is lexicographically less than or equal to c-string c_str.
bool CEGUIEXPORT | operator<= (const char *c_str, const String &str)
| Return true if c-string c_str is lexicographically less than or equal to String str.
bool CEGUIEXPORT | operator>= (const String &str, const char *c_str)
| Return true if String str is lexicographically greater than or equal to c-string c_str.
bool CEGUIEXPORT | operator>= (const char *c_str, const String &str)
| Return true if c-string c_str is lexicographically greater than or equal to String str.
String CEGUIEXPORT | operator+ (const String &str1, const String &str2)
| Return String object that is the concatenation of the given inputs.
String CEGUIEXPORT | operator+ (const String &str, const std::string &std_str)
| Return String object that is the concatenation of the given inputs.
String CEGUIEXPORT | operator+ (const std::string &std_str, const String &str)
| Return String object that is the concatenation of the given inputs.
String CEGUIEXPORT | operator+ (const String &str, const utf8 *utf8_str)
| Return String object that is the concatenation of the given inputs.
String CEGUIEXPORT | operator+ (const utf8 *utf8_str, const String &str)
| Return String object that is the concatenation of the given inputs.
String CEGUIEXPORT | operator+ (const String &str, utf32 code_point)
| Return String object that is the concatenation of the given inputs.
String CEGUIEXPORT | operator+ (utf32 code_point, const String &str)
| Return String object that is the concatenation of the given inputs.
String CEGUIEXPORT | operator+ (const String &str, const char *c_str)
| Return String object that is the concatenation of the given inputs.
String CEGUIEXPORT | operator+ (const char *c_str, const String &str)
| Return String object that is the concatenation of the given inputs.
CEGUIEXPORT std::ostream & | operator<< (std::ostream &s, const String &str)
void CEGUIEXPORT | swap (String &str1, String &str2)
| Swap the contents for two String objects.
bool | lbi_less (const ListboxItem *a, const ListboxItem *b)
| Helper function used in sorting to compare two list box item text strings via the ListboxItem pointers and return if a is less than b.
bool | lbi_greater (const ListboxItem *a, const ListboxItem *b)
| Helper function used in sorting to compare two list box item text strings via the ListboxItem pointers and return if a is greater than b.
CFBundleRef | mac_loadExeBundle (const char *name)
void * | mac_getBundleSym (CFBundleRef bundle, const char *name)
bool | mac_unloadExeBundle (CFBundleRef bundle)
const char * | mac_errorBundle ()

## Variables

static const float | DefaultNativeHorzRes = 640.0f
| Default native horizontal resolution (for fonts and imagesets).
static const float | DefaultNativeVertRes = 480.0f
| Default native vertical resolution (for fonts and imagesets).

## Detailed Description

Main namespace for Crazy Eddie's GUI Library.

The CEGUI namespace contains all the classes and other items that comprise the core of Crazy Eddie's GUI system.

## Enumeration Type Documentation

enum CEGUI::DimensionOperator

Enumeration of values representing mathematical operations on dimensions.

Enumerator:

  DOP_NOOP | Do nothing operator.
  DOP_ADD | Dims should be added.
  DOP_SUBTRACT | Dims should be subtracted.
  DOP_MULTIPLY | Dims should be multiplied.
  DOP_DIVIDE | Dims should be divided.

enum CEGUI::DimensionType

Enumeration of possible values to indicate what a given dimension represents.

Enumerator:

  DT_LEFT_EDGE | Dimension represents the left edge of some entity (same as DT_X_POSITION).
  DT_X_POSITION | Dimension represents the x position of some entity (same as DT_LEFT_EDGE).
  DT_TOP_EDGE | Dimension represents the top edge of some entity (same as DT_Y_POSITION).
  DT_Y_POSITION | Dimension represents the y position of some entity (same as DT_TOP_EDGE).
  DT_RIGHT_EDGE | Dimension represents the right edge of some entity.
  DT_BOTTOM_EDGE | Dimension represents the bottom edge of some entity.
  DT_WIDTH | Dimension represents the width of some entity.
  DT_HEIGHT | Dimension represents the height of some entity.
  DT_X_OFFSET | Dimension represents the x offset of some entity (usually only applies to an Image entity).
  DT_Y_OFFSET | Dimension represents the y offset of some entity (usually only applies to an Image entity).
  DT_INVALID | Invalid / uninitialised DimensionType.

enum CEGUI::FontFlag

Enumerated type that contains the valid flags that can be passed to createFont when creating a new font.

Enumerator:

  Default | Default / None.
  NoAntiAlias | Fonts generated from TrueType files should not be anti-aliased.

enum CEGUI::FontMetricType

Enumeration of possible values to indicate a particular font metric.

Enumerator:

  FMT_LINE_SPACING | Vertical line spacing value for font.
  FMT_BASELINE | Vertical baseline value for font.
  FMT_HORZ_EXTENT | Horizontal extent of a string.

enum CEGUI::FrameImageComponent

Enumeration of values referencing available images forming a frame component.

Enumerator:

  FIC_BACKGROUND | References image used for the background.
  FIC_TOP_LEFT_CORNER | References image used for the top-left corner.
  FIC_TOP_RIGHT_CORNER | References image used for the top-right corner.
  FIC_BOTTOM_LEFT_CORNER | References image used for the bottom-left corner.
  FIC_BOTTOM_RIGHT_CORNER | References image used for the bottom-right corner.
  FIC_LEFT_EDGE | References image used for the left edge.
  FIC_RIGHT_EDGE | References image used for the right edge.
  FIC_TOP_EDGE | References image used for the top edge.
  FIC_BOTTOM_EDGE | References image used for the bottom edge.
  FIC_FRAME_IMAGE_COUNT | Max number of images for a frame.

enum CEGUI::HorizontalAlignment

Enumerated type used when specifying horizontal alignments.

Enumerator:

  HA_LEFT | Elements position specifies an offset of it's left edge from the left edge of it's parent.
  HA_CENTRE | Elements position specifies an offset of it's horizontal centre from the horizontal centre of it's parent.
  HA_RIGHT | Elements position specifies an offset of it's right edge from the right edge of it's parent.

enum CEGUI::HorizontalFormatting

Enumeration of possible values to indicate the horizontal formatting to be used for an image component.

Enumerator:

  HF_LEFT_ALIGNED | Left of Image should be aligned with the left of the destination area.
  HF_CENTRE_ALIGNED | Image should be horizontally centred within the destination area.
  HF_RIGHT_ALIGNED | Right of Image should be aligned with the right of the destination area.
  HF_STRETCHED | Image should be stretched horizontally to fill the destination area.
  HF_TILED | Image should be tiled horizontally to fill the destination area (right-most tile may be clipped).

enum CEGUI::HorizontalTextFormatting

Enumeration of possible values to indicate the horizontal formatting to be used for a text component.

Enumerator:

  HTF_LEFT_ALIGNED | Left of text should be aligned with the left of the destination area (single line of text only).
  HTF_RIGHT_ALIGNED | Right of text should be aligned with the right of the destination area (single line of text only).
  HTF_CENTRE_ALIGNED | text should be horizontally centred within the destination area (single line of text only).
  HTF_JUSTIFIED | text should be spaced so that it takes the full width of the destination area (single line of text only).
  HTF_WORDWRAP_LEFT_ALIGNED | Left of text should be aligned with the left of the destination area (word wrapped to multiple lines as needed).
  HTF_WORDWRAP_RIGHT_ALIGNED | Right of text should be aligned with the right of the destination area (word wrapped to multiple lines as needed).
  HTF_WORDWRAP_CENTRE_ALIGNED | text should be horizontally centred within the destination area (word wrapped to multiple lines as needed).
  HTF_WORDWRAP_JUSTIFIED | text should be spaced so that it takes the full width of the destination area (word wrapped to multiple lines as needed).

enum CEGUI::LoggingLevel

Enumeration of logging levels.

Enumerator:

  Errors | Only actual error conditions will be logged.
  Standard | Basic events will be logged (default level).
  Informative | Useful tracing (object creations etc) information will be logged.
  Insane | Mostly everything gets logged (use for heavy tracing only, log WILL be big).

enum CEGUI::MetricsMode

Mode used for Window size and position metrics.

Position information for a Window is always 'relative' to it's parent even in Absolute mode. In Relative mode, layout is maintained for different screen resolutions, and also offers the ability for child windows to properly adjust their layout as their parent is sized.

Enumerator:

  Relative | Metrics are specified as a decimal fraction of parent Window size.
  Absolute | Metrics are specified as whole pixels.
  Inherited | Metrics are inherited from parent.

enum CEGUI::MouseButton

/brief Enumeration of mouse buttons

Enumerator:

  NoButton | Value set for no mouse button. NB: This is not 0, do not assume!

enum CEGUI::MouseCursorImage

Enumeration of special values used for mouse cursor settings in Window objects.

Enumerator:

  BlankMouseCursor | No image should be displayed for the mouse cursor.
  DefaultMouseCursor | The default mouse cursor image should be displayed.

enum CEGUI::OrientationFlags

Enumerated type that contains the valid flags that can be to use when rendering image.

Enumerator:

  FlipHorizontal | Horizontal flip the image.
  FlipVertical | Vertical flip the image.
  RotateRightAngle | Rotate the image anticlockwise 90 degree.

enum CEGUI::QuadSplitMode

Enumerated type that contains the valid diagonal-mode that specify how a quad is split into triangles when rendered with fx. a 3D API.

Enumerator:

  TopLeftToBottomRight | Diagonal goes from top-left to bottom-right.
  BottomLeftToTopRight | Diagonal goes from bottom-left to top-right.

enum CEGUI::SystemKey

System key flag values.

Enumerator:

  LeftMouse | The left mouse button.
  RightMouse | The right mouse button.
  Shift | Either shift key.
  Control | Either control key.
  MiddleMouse | The middle mouse button.
  X1Mouse | The first 'extra' mouse button.
  X2Mouse | The second 'extra' mouse button.
  Alt | Either alt key.

enum CEGUI::TextFormatting

Enumerated type that contains valid formatting types that can be specified when rendering text into a Rect area (the formatting Rect).

Enumerator:

  LeftAligned | All text is printed on a single line. The left-most character is aligned with the left edge of the formatting Rect.
  RightAligned | All text is printed on a single line. The right-most character is aligned with the right edge of the formatting Rect.
  Centred | All text is printed on a single line. The text is centred horizontally in the formatting Rect.
  Justified | All text is printed on a single line. The left-most and right-most characters are aligned with the edges of the formatting Rect.
  WordWrapLeftAligned | Text is broken into multiple lines no wider than the formatting Rect. The left-most character of each line is aligned with the left edge of the formatting Rect.
  WordWrapRightAligned | Text is broken into multiple lines no wider than the formatting Rect. The right-most character of each line is aligned with the right edge of the formatting Rect.
  WordWrapCentred | Text is broken into multiple lines no wider than the formatting Rect. Each line is centred horizontally in the formatting Rect.
  WordWrapJustified | Text is broken into multiple lines no wider than the formatting Rect. The left-most and right-most characters of each line are aligned with the edges of the formatting Rect.

enum CEGUI::VerticalAlignment

Enumerated type used when specifying vertical alignments.

Enumerator:

  VA_TOP | Elements position specifies an offset of it's top edge from the top edge of it's parent.
  VA_CENTRE | Elements position specifies an offset of it's vertical centre from the vertical centre of it's parent.
  VA_BOTTOM | Elements position specifies an offset of it's bottom edge from the bottom edge of it's parent.

enum CEGUI::VerticalFormatting

Enumeration of possible values to indicate the vertical formatting to be used for an image component.

Enumerator:

  VF_TOP_ALIGNED | Top of Image should be aligned with the top of the destination area.
  VF_CENTRE_ALIGNED | Image should be vertically centred within the destination area.
  VF_BOTTOM_ALIGNED | Bottom of Image should be aligned with the bottom of the destination area.
  VF_STRETCHED | Image should be stretched vertically to fill the destination area.
  VF_TILED | Image should be tiled vertically to fill the destination area (bottom-most tile may be clipped).

enum CEGUI::VerticalTextFormatting

Enumeration of possible values to indicate the vertical formatting to be used for a text component.

Enumerator:

  VTF_TOP_ALIGNED | Top of text should be aligned with the top of the destination area.
  VTF_CENTRE_ALIGNED | text should be vertically centred within the destination area.
  VTF_BOTTOM_ALIGNED | Bottom of text should be aligned with the bottom of the destination area.

## Function Documentation

String CEGUI::operator+ | ( | const char * | c_str,
|  | const String & | str
| ) |

Return String object that is the concatenation of the given inputs.

Parameters:

  | c_str | c-string describing the first part of the new string
  | str | String object describing the second part of the new string

Returns:
  A String object that is the concatenation of c_str and str

Exceptions:

  | std::length_error | Thrown if the resulting String would be too large.

String CEGUI::operator+ | ( | const String & | str,
|  | const char * | c_str
| ) |

Return String object that is the concatenation of the given inputs.

Parameters:

  | str | String object describing first part of the new string
  | c_str | c-string describing the second part of the new string

Returns:
  A String object that is the concatenation of str and c_str

Exceptions:

  | std::length_error | Thrown if the resulting String would be too large.

String CEGUI::operator+ | ( | utf32 | code_point,
|  | const String & | str
| ) |

Return String object that is the concatenation of the given inputs.

Parameters:

  | code_point | utf32 code point describing the first part of the new string
  | str | String object describing the second part of the new string

Returns:
  A String object that is the concatenation of code_point and str

Exceptions:

  | std::length_error | Thrown if the resulting String would be too large.

String CEGUI::operator+ | ( | const String & | str,
|  | utf32 | code_point
| ) |

Return String object that is the concatenation of the given inputs.

Parameters:

  | str | String object describing the first part of the new string
  | code_point | utf32 code point describing the second part of the new string

Returns:
  A String object that is the concatenation of str and code_point

Exceptions:

  | std::length_error | Thrown if the resulting String would be too large.

String CEGUI::operator+ | ( | const utf8 * | utf8_str,
|  | const String & | str
| ) |

Return String object that is the concatenation of the given inputs.

Parameters:

  | utf8_str | Buffer containing null-terminated utf8 encoded data describing the first part of the new string
  | str | String object describing the second part of the new string

Returns:
  A String object that is the concatenation of str and utf8_str

Exceptions:

  | std::length_error | Thrown if the resulting String would be too large.

String CEGUI::operator+ | ( | const String & | str,
|  | const utf8 * | utf8_str
| ) |

Return String object that is the concatenation of the given inputs.

Parameters:

  | str | String object describing first part of the new string
  | utf8_str | Buffer containing null-terminated utf8 encoded data describing the second part of the new string

Returns:
  A String object that is the concatenation of str and utf8_str

Exceptions:

  | std::length_error | Thrown if the resulting String would be too large.

String CEGUI::operator+ | ( | const std::string & | std_str,
|  | const String & | str
| ) |

Return String object that is the concatenation of the given inputs.

Parameters:

  | std_str | std::string object describing the first part of the new string
  | str | String object describing the second part of the new string

Returns:
  A String object that is the concatenation of std_str and str

Exceptions:

  | std::length_error | Thrown if the resulting String would be too large.

String CEGUI::operator+ | ( | const String & | str,
|  | const std::string & | std_str
| ) |

Return String object that is the concatenation of the given inputs.

Parameters:

  | str | String object describing first part of the new string
  | std_str | std::string object describing the second part of the new string

Returns:
  A String object that is the concatenation of str and std_str

Exceptions:

  | std::length_error | Thrown if the resulting String would be too large.

String CEGUI::operator+ | ( | const String & | str1,
|  | const String & | str2
| ) |

Return String object that is the concatenation of the given inputs.

Parameters:

  | str1 | String object describing first part of the new string
  | str2 | String object describing the second part of the new string

Returns:
  A String object that is the concatenation of str1 and str2

Exceptions:

  | std::length_error | Thrown if the resulting String would be too large.

void CEGUI::swap | ( | String & | str1,
|  | String & | str2
| ) |

Swap the contents for two String objects.

Parameters:

  | str1 | String object who's contents are to be swapped with str2
  | str2 | String object who's contents are to be swapped with str1

Returns:
  Nothing